<html>
<head>
<title>SoapClient</title>
</head>
<body>
<?php

error_reporting(E_ALL);
ini_set("display_errors", 1);

$nPort = 8072;

//autoload
spl_autoload_extensions(".php"); // comma-separated list
spl_autoload_register();


use Wsdl2Php\PackageBase\AbstractSoapClientBase;
$options = array(
    AbstractSoapClientBase::WSDL_TRACE=>1,
    AbstractSoapClientBase::WSDL_EXCEPTIONS=>1,  //optional parameters for debugging
    AbstractSoapClientBase::WSDL_STREAM_CONTEXT => stream_context_create(array('http' => array(
        'header' => "x-SIMAXService-Client: Proxy-SOAPClient\nx-SIMAXService-Client-Version: 01.1631.01\nx-SIMAXService-Client-IP: ".$_SERVER["REMOTE_ADDR"],
        ))),
    AbstractSoapClientBase::WSDL_URL => "http://127.0.0.1:$nPort/getwsdl",
    AbstractSoapClientBase::WSDL_PROXY_HOST => "127.0.0.1",
    AbstractSoapClientBase::WSDL_PROXY_PORT => "$nPort",
    AbstractSoapClientBase::WSDL_CLASSMAP => \Wsdl2Php\ClassMap::get(),
    AbstractSoapClientBase::WSDL_SOAP_VERSION => SOAP_1_1,
);
// if getList operation is provided by the Web service
$oSOAPClient = new \Wsdl2Php\ServiceType\Service($options);

$usernameToken = new \Entity\UsernameToken('superviseur', '');


//-------------------------------------------------------------
//ETAPE DE CONNEXION
$usernameToken->ComputeCryptedPassword();
$stGetTokenSessionParam = new \Wsdl2Php\StructType\GetTokenSession($usernameToken);
$result = $oSOAPClient->GetTokenSession($stGetTokenSessionParam);
$oSOAPClient->log('GetTokenSession');

//on a le token de session qui va nous servir par la suite
$sessionToken = $result->SessionToken;
$oSOAPClient->setSoapHeaderSessionToken($sessionToken);

//-------------------------------------------------------------
//ETAPE DE CREATION D'UNE VILLE
//on recalcule le username token
$usernameToken->ComputeCryptedPassword();
$oSOAPClient->setSoapHeaderUsernameToken($usernameToken);

$stCreate = new \Wsdl2Php\StructType\Create('9494');
$result = $oSOAPClient->Create($stCreate);
$oSOAPClient->log('Creer ville');

//-----------------------------------------------------------
//Etape de recherche d'un pays
//$usernameToken->ComputeCryptedPassword();
//$oSOAPClient->setSoapHeaderUsernameToken($usernameToken);
//$oSOAPClient->setSoapHeaderActionContext($oSOAPClient->getSoapHeaderActionContext());
//$oSOAPClient->setSoapHeaderAutoValidate(-1);
//
//$stSearch = new \Wsdl2Php\StructType\Search('9495', '', null, "52176367525111", null, \wsdl2php\EnumType\DisplayModeParamEnum::VALUE_LIST); //rechercher pays
//$result = $oSOAPClient->Search($stSearch);
//$oSOAPClient->log('Rechercher Pays');


//-----------------------------------------------------------
//ETAPE DE LA MISE A JOUR DU CONTENU AVEC VALIDATION
$usernameToken->ComputeCryptedPassword();
$oSOAPClient->setSoapHeaderUsernameToken($usernameToken);

$simplexml = simplexml_load_string($result->getXml());
$idsimax = (string)$simplexml->id_9494->attributes('http://www.nout.fr/XML/')['id'];

$oSOAPClient->setSoapHeaderActionContext($oSOAPClient->getSoapHeaderActionContext());
$oSOAPClient->setSoapHeaderAutoValidate(1);


$updateXML="<xml>
<id_9494>
<id_9489>".'Script PHP '.base64_encode(microtime())."</id_9489>
<id_45957764764076>47997784314920</id_45957764764076>
</id_9494>
</xml>";

$stUpdate = new \Wsdl2Php\StructType\Update('9494', "<id_9494>$idsimax</id_9494>", 0, $updateXML);
$result = $oSOAPClient->Update($stUpdate);
$oSOAPClient->log('Update en autovalidate');


//-------------------------------------------------------------
$oSOAPClient->setSoapHeaderActionContext(null);
$oSOAPClient->setSoapHeaderAutoValidate(-1);

//REQUETE SUR LES VILLES

$stRequest = new \Wsdl2Php\StructType\Request('9494');  //9488
$sCondList = "<Condition>
    <CondCol>9488</CondCol>
    <CondType>Equal</CondType>
    <CondValue>$idsimax</CondValue>
</Condition>";
$stRequest->setCondList($sCondList);
$result = $oSOAPClient->Request($stRequest);
$oSOAPClient->log('Requête sur Ville');



//-------------------------------------------------------------
//ETAPE de DECONNEXION

$oSOAPClient->setSoapHeaderActionContext(null);
$oSOAPClient->setSoapHeaderAutoValidate(null);

//on recalcule le username token
$usernameToken->ComputeCryptedPassword();
$oSOAPClient->setSoapHeaderUsernameToken($usernameToken);

$result = $oSOAPClient->Disconnect(null);
$oSOAPClient->log('Disconnect');

?>
</body>
</html>